'****************************************************************************
'           COWCAMP  2
'____________________________________________________________________________

'   By Jim Moore , Seattle, WA   1991
'
' A graphics presentation to demonstrate the use of page flipping techniques
' in the EGA 320 x 200 16 color mode. This program has been developed on and
' is designed to be compiled on the Quick Basic 4.x compiler. An EGA or VGA
' card and monitor are required for execution.
'
'____________________________________________________________________________

'set text mode and colors
SCREEN 0: WIDTH 80: COLOR 14, 0
'introduction text
CLS
PRINT "COWCAMP 2   By Jim Moore   1991"
PRINT
PRINT " This simple animation sequence will demonstrate the use of page flip-"
PRINT "ping techniques in the EGA 320 x 200 16 color mode. The image files "
PRINT "will first be loaded from disk in 4 color planes (red,blue,green and"
PRINT "intensity), then the illusion of movement will be accomplished by "
PRINT "switching between the 3 pages. Seven pages are possible."
COLOR 4
PRINT
PRINT "   This program requires an EGA or VGA card & monitor."
PRINT
PRINT
COLOR 2
PRINT "       Press any key to BEGIN and any key to END"

'loop until key is pressed
WHILE INKEY$ = ""
WEND

CLS

'set screen mode to 320x200 16 color graphics
'and clear video pages 0,1 and 2
SCREEN 7, 0, 0, 0: CLS : SCREEN , , 1, 0: CLS : SCREEN , , 2, 0: CLS

SCREEN , , 0, 0                'open with visible page 0
DEFINT A-Z                     'define alpha character variables as integers

'load the 4 planes of the first image
DEF SEG = &HA000               'point to video buffer segment
OUT &H3C4, 2: OUT &H3C5, 1
BLOAD "cwbx1.bld", 0
OUT &H3C4, 2: OUT &H3C5, 2
BLOAD "cwbx2.bld", 0
OUT &H3C4, 2: OUT &H3C5, 4
BLOAD "cwbx3.bld", 0
OUT &H3C4, 2: OUT &H3C5, 8
BLOAD "cwbx4.bld", 0
OUT &H3C4, 2: OUT &H3C5, &HF
PCOPY 0, 1                     'copy visible page to hidden page 1
DEF SEG                        'restore segment
CLS                            'clear screen

'load 4 planes of second image
DEF SEG = &HA000               'point to video buffer segment
OUT &H3C4, 2: OUT &H3C5, 1
BLOAD "cwby1.bld", 0
OUT &H3C4, 2: OUT &H3C5, 2
BLOAD "cwby2.bld", 0
OUT &H3C4, 2: OUT &H3C5, 4
BLOAD "cwby3.bld", 0
OUT &H3C4, 2: OUT &H3C5, 8
BLOAD "cwby4.bld", 0
OUT &H3C4, 2: OUT &H3C5, &HF
PCOPY 0, 2                     'copy visible page to hidden page 2
DEF SEG                        'restore segment
CLS                            'clear screen

'load 4 planes of third image
DEF SEG = &HA000               'point to video buffer segment
OUT &H3C4, 2: OUT &H3C5, 1
BLOAD "cwbz1.bld", 0
OUT &H3C4, 2: OUT &H3C5, 2
BLOAD "cwbz2.bld", 0
OUT &H3C4, 2: OUT &H3C5, 4
BLOAD "cwbz3.bld", 0
OUT &H3C4, 2: OUT &H3C5, 8
BLOAD "cwbz4.bld", 0
OUT &H3C4, 2: OUT &H3C5, &HF
DEF SEG                        'restore segment and latches

'There are 7 possible video pages in this mode including the visible page.
'only 3 are used in this routine.

' animation loop (flip the pages)
DO WHILE INKEY$ = ""
SCREEN , , , 1         'display video page 1
SCREEN , , , 2         'display video page 2
SCREEN , , , 0         'display video page 0
LOOP                                  'repeat if key hasn't been pressed

'clear all video pages used and restore to text mode and end.
CLS : SCREEN , , 0, 0: CLS : SCREEN , , 1, 0: CLS : SCREEN , , 2, 0: CLS
SCREEN 0, 0, 0, 0: WIDTH 80: COLOR 7, 0: CLS
END

'****************************************************************************

